package de.hdm_stuttgart.battlearena.Controller;

import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;
import javafx.stage.Stage;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Objects;
import java.util.ResourceBundle;

public class IntroController implements Initializable {

    @FXML
    public MediaView mediaView;
    @FXML
    public BorderPane introParent;
    private final String fileName = "src/main/resources/textures/videos/";
//    nextVideo() will iterate through this array so the next video will be played TODO: change the videos to non memes lmao
    private final String[] videos = {"sony.mp4", "gamecube.mp4", "gameboy.mp4", "monke.mp4"};
    private File file = new File(fileName + videos[0]);
    private int counter = 0;
    private MediaPlayer mediaPlayer;

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        introParent.setStyle("-fx-background-color: black;");
        createMediaPlayer();
    }

    private void createMediaPlayer() {
        Media media = new Media(file.toURI().toString());
        mediaPlayer = new MediaPlayer(media);
        mediaView.setMediaPlayer(mediaPlayer);

//      resizing once the scenes has been loaded to get width and height property
        mediaPlayer.setOnReady(() -> {
            mediaView.fitWidthProperty().bind(introParent.getScene().widthProperty());
            mediaView.fitHeightProperty().bind(introParent.getScene().heightProperty());
        });
        mediaPlayer.setAutoPlay(true);
        mediaPlayer.setOnEndOfMedia(() -> {
            if (counter == videos.length - 1) {
                videoEnd();
            } else {
                nextVideo();
            }
        });

//        TODO: make any button pressed work
        introParent.setOnMouseClicked((mouseEvent) -> {
            if (counter == videos.length - 1) {
                videoEnd();
            } else {
                nextVideo();
            }
        });
    }

//        TODO: maybe look into using SceneLoader class
    private void videoEnd() {
        try {
            mediaPlayer.dispose();
            Parent root = FXMLLoader.load(Objects.requireNonNull(getClass().getResource("/fxml/MenuBorderPane.fxml")));
            Stage stage = (Stage) introParent.getScene().getWindow();
            Scene scene = new Scene(root);
            scene.getStylesheets().add(Objects.requireNonNull(this.getClass().getResource("/styles/style.css")).toExternalForm());
            stage.setScene(scene);
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    private void nextVideo() {
        mediaPlayer.dispose();
        file = new File(fileName + videos[counter + 1]);
        counter++;
        createMediaPlayer();
    }
}
